Name:           jss
Version:        4.2.6
Release:        25.99%{?dist}
Summary:        Java Security Services (JSS)

Group:          System Environment/Libraries
License:        MPLv1.1 or GPLv2+ or LGPLv2+
URL:            http://www.mozilla.org/projects/security/pki/jss/
# The source for this package was pulled from upstream's cvs. Use the
# following commands to generate the tarball:
# cvs -d :pserver:anonymous@cvs-mirror.mozilla.org:/cvsroot export -r JSS_4_2_6_RTM -d jss-4.2.6 -N mozilla/security/coreconf mozilla/security/jss
# tar -czvf jss-4.2.6.tar.gz jss-4.2.6
Source0:        http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}-%{release}/%{name}-%{version}.tar.gz
Source1:        http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}-%{release}/MPL-1.1.txt
Source2:        http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}-%{release}/gpl.txt
Source3:        http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}-%{release}/lgpl.txt
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%define pki_jdk           java-devel >= 1:1.6.0
%define pki_open_jdk      java-devel-openjdk >= 1:1.6.0
%define pki_open_jre      java-1.6.0-openjdk
# Override the default 'pki_jdk' on Fedora 8 platforms
%{?fc8:%define pki_jdk        java-devel >= 1.7.0}
%{?fc8:%define pki_open_jdk   java-devel-icedtea >= 1.7.0}
%{?fc8:%define pki_open_jre   java-1.7.0-icedtea}

BuildRequires:  nss-devel >= 3.13.5-8
BuildRequires:  %{pki_jdk}
BuildRequires:  pkgconfig
# Force use of OpenJDK for development
BuildRequires:  %{pki_open_jdk}
Requires:       nss >= 3.13.5-8
# Urge use of OpenJDK for runtime
Requires:       %{pki_open_jre}

# don't use sun.net.www.protocol.http.HttpURLConnection.userAgent
Patch1:         jss-key_pair_usage_with_op_flags.patch
Patch2:         jss-javadocs-param.patch
Patch3:         jss-ipv6.patch
Patch4:         jss-ECC-pop.patch
#Patch5:         jss-loadlibrary.patch
Patch6:         jss-ocspSettings.patch
Patch7:         jss-ECC_keygen_byCurveName.patch
Patch8:         jss-VerifyCertificate.patch
Patch9:         jss-bad-error-string-pointer.patch
Patch10:        jss-VerifyCertificateReturnCU.patch
#Patch11:        jss-slots-not-freed.patch
Patch12:        jss-ECC-HSM-FIPS.patch
Patch13:        jss-eliminate-native-compiler-warnings.patch
Patch14:        jss-eliminate-java-compiler-warnings.patch
Patch15:        jss-PKCS12-FIPS.patch
Patch16:        jss-eliminate-native-coverity-defects.patch
Patch17:        jss-PBE-PKCS5-V2-secure-P12.patch
Patch18:        jss-wrapInToken.patch
Patch19:        jss-HSM-manufacturerID.patch
Patch20:        jss-ECC-Phase2KeyArchivalRecovery.patch
Patch21:        jss-undo-JCA-deprecations.patch
Patch22:        jss-undo-BadPaddingException-deprecation.patch
Patch23:        jss-lunasa-keyUnwrap.patch
Patch24:        jss-ECC-SignerInfo.patch

%description
Java Security Services (JSS) is a java native interface which provides a bridge
for java-based applications to use native Network Security Services (NSS).
This only works with JREs that do NOT require that JCE providers be signed.


# Technically, javadoc packages should be "noarch" architecture.  However,
# building a "noarch" subpackage from a non-"noarch" master package is NOT
# supported until RPM 4.6.0.
%package javadoc
Summary:        Java Security Services (JSS) Javadocs
Group:          Development/Documentation
Requires:       jss = %{version}-%{release}

%description javadoc
Java Security Services (JSS) Javadocs

This documentation pertains exclusively to JSS %{version}. 


%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
#%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
#%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1

%build
[ -z "$JAVA_HOME" ] && export JAVA_HOME=%{_jvmdir}/java

%ifarch i386
JAVA_HOME=/usr/lib/jvm/java-1.6.0-openjdk
%{?fc8:JAVA_HOME=/usr/lib/jvm/java-1.7.0-icedtea}
export JAVA_HOME
%endif

%ifarch x86_64
JAVA_HOME=/usr/lib/jvm/java-1.6.0-openjdk.x86_64
%{?fc8:JAVA_HOME=/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64}
export JAVA_HOME
%endif

# Enable compiler optimizations and disable debugging code
BUILD_OPT=1
export BUILD_OPT

# Generate symbolic info for debuggers
XCFLAGS="-g $RPM_OPT_FLAGS"
export XCFLAGS

PKG_CONFIG_ALLOW_SYSTEM_LIBS=1
PKG_CONFIG_ALLOW_SYSTEM_CFLAGS=1

export PKG_CONFIG_ALLOW_SYSTEM_LIBS
export PKG_CONFIG_ALLOW_SYSTEM_CFLAGS

NSPR_INCLUDE_DIR=`/usr/bin/pkg-config --cflags-only-I nspr | sed 's/-I//'`
NSPR_LIB_DIR=`/usr/bin/pkg-config --libs-only-L nspr | sed 's/-L//'`

NSS_INCLUDE_DIR=`/usr/bin/pkg-config --cflags-only-I nss | sed 's/-I//'`
NSS_LIB_DIR=`/usr/bin/pkg-config --libs-only-L nss | sed 's/-L//'`

export NSPR_INCLUDE_DIR
export NSPR_LIB_DIR
export NSS_INCLUDE_DIR
export NSS_LIB_DIR

%ifarch x86_64 ppc64 ia64 s390x sparc64
USE_64=1
export USE_64
%endif

# The Makefile is not thread-safe
make -C mozilla/security/coreconf
make -C mozilla/security/jss
make -C mozilla/security/jss javadoc

%install
rm -rf ${RPM_BUILD_ROOT} docdir

# Copy the license files here so we can include them in %doc
cp -p %{SOURCE1} .
cp -p %{SOURCE2} .
cp -p %{SOURCE3} .

# There is no install target so we'll do it by hand

# Version Definitions
%define major_version     $(echo "%{version}" | sed 's/[ .][0-9]*[ .][0-9]*//')
%define minor_version     $(echo "%{version}" | sed 's/^[0-9]*[ .]//' | sed 's/[ .][0-9]*//')
%define patch_version     $(echo "%{version}" | sed 's/^[0-9]*[ .][0-9]*[ .]//')

# FIXME - sign jss%{major_version}.jar. In order to use JSS as a JCE provider
# it needs to be signed with a Sun-issued certificate. Since we would need to
# make this certificate and private key public to provide reproducability in
# the rpm building we have to ship an unsigned jar.
#
# Instructions for getting a signing cert can be found here:
# http://java.sun.com/javase/6/docs/technotes/guides/security/crypto/HowToImplAProvider.html#Step61
#
# This signing is not required by every JVM. gcj ignores the signature and does
# not require one. The Sun and IBM JVMs both check and enforce the signature.
# OpenJDK and its predecessors (such as Iced Tea) also ignore the signature.
# Behavior of other JVMs is not known but they probably enforce the signature
# as well.
#
%define rpm_sign_exists %(test -x /usr/bin/rpm-sign && echo 1 || echo 0)
%if %{rpm_sign_exists}
#
# Use the restricted 'rpm-sign' executable to sign jars:
#
%define sign_jss_jar %(echo "rpm-sign --jarsign --key jcesigncert jss%{major_version}-%{version}.jar")
%define verify_jss_jar %(echo "jarsigner --verify --verbose jss%{major_version}-%{version}.jar")
%endif

# jars
install -d -m 0755 ${RPM_BUILD_ROOT}%{_jnidir}
install -m 644 mozilla/dist/xpclass.jar ${RPM_BUILD_ROOT}%{_jnidir}/jss%{major_version}-%{version}.jar
pushd  ${RPM_BUILD_ROOT}%{_jnidir}
    %{?sign_jss_jar}
    %{?verify_jss_jar}
    ln -fs jss%{major_version}-%{version}.jar jss%{major_version}.jar
popd

# We have to use the name libjss%{major_version}.so because this is dynamically
# loaded by the jar file.
install -d -m 0755 ${RPM_BUILD_ROOT}%{_libdir}
install -m 0755 mozilla/dist/Linux*.OBJ/lib/libjss%{major_version}.so ${RPM_BUILD_ROOT}%{_libdir}/
pushd  ${RPM_BUILD_ROOT}%{_libdir}
    ln -fs %{_jnidir}/jss%{major_version}.jar jss%{major_version}.jar
popd

# javadoc
install -d -m 0755 ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}
cp -rp mozilla/dist/jssdoc/* ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}

%clean
rm -rf ${RPM_BUILD_ROOT}

# No ldconfig is required since this library is loaded by Java itself.
%files
%defattr(-,root,root,-)
%doc mozilla/security/jss/jss.html MPL-1.1.txt gpl.txt lgpl.txt
%{_jnidir}/*
%{_libdir}/lib*.so
%{_libdir}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*


%changelog
* Wed Jun 1 2013 Christina Fu <cfu@redhat.com> - 4.2.6-25.99
- Bugzilla 744207 - Key archival fails when KRA is configured with lunasa.
- Bugzilla Bug #952500 CMCAuth fails with error "CMCAuth:
  java.security.NoSuchAlgorithmException" when using NetHSM token
- added source URLs in spec file to pass Package Wrangler

* Fri Mar 30 2012 Matthew Harmsen <mharmsen@redhat.com> - 4.2.6-23.99
- Bugzilla Bug #797352 - Un-deprecate previously deprecated methods in
  JSS 4.2.6 . . . BadPaddingException (mharmsen)

* Tue Mar 20 2012 Christina Fu <cfu@redhat.com> - 4.2.6-22.99
- Bugzilla Bug #745278 - [RFE] ECC encryption keys cannot be archived
  ECC phase2 work - support for ECC encryption key archival and recovery (cfu)
- Bugzilla Bug #797352 - Un-deprecate previously deprecated methods in
  JSS 4.2.6 . . . (mharmsen)
- Dogtag TRAC Task #109 (https://fedorahosted.org/pki/ticket/109) - add
  benign JNI jar file symbolic link from JNI libdir to JNI jar file (mharmsen)

* Thu Nov 10 2011 Christina Fu <cfu@redhat.com> - 4.2.6-21.99
- Bugzilla Bug #752880 - JSS - HSM token name was mistaken for manufacturer
  identifier

* Wed Oct 19 2011 Christina Fu <cfu@redhat.com> - 4.2.6-20.99
- Bugzilla Bug #744797 - KRA key recovery (retrieve pkcs#12) fails after the
  in-place upgrade( CS 8.0->8.1)

* Fri Oct 14 2011 Matthew Harmsen <mharmsen@redhat.com> - 4.2.6-19.99
- Bugzilla Bug #715621 - Defects revealed by Coverity scan
- inserting patch prior to jss-PBE-PKCS5-V2-secure-P12.patch

* Thu Sep 23 2011 Christina Fu <cfu@redhat.com> - 4.2.6-18.999
- Bugzilla Bug #737122 - DRM: during archiving and recovering, wrapping
  unwrapping keys should be done in the token
- support for PKCS5v2; support for secure PKCS12

* Mon Aug 15 2011 Christina Fu <cfu@redhat.com> - 4.2.6-18.99
- Bugzilla Bug 730164 - DRM failed to recovery keys when in FIPS mode (HSM + NSS)

* Fri Aug 12 2011 Matthew Harmsen <mharmsen@redhat.com> - 4.2.6-17.99
- Bugzilla Bug #660436 - Warnings should be cleaned up in JSS build
  (jdennis, mharmsen)

* Wed May 18 2011 Christina Fu <cfu@redhat.com> - 4.2.6-16.99.
- Bug 670980 - Cannot create system certs when using LunaSA HSM in FIPS Mode and ECC algorithms (support tokens that don't do ECDH)

* Fri Apr 08 2011 Jack Magne <jmagne@redhat.com> - 4.2.6-15.99
- bug 694661 - TKS instance crash during token enrollment.
  Back out of previous patch for #676083.

* Mon Feb 28 2011 Andrew Wnuk <awnuk@redhat.com> - 4.2.6-15
- bug 676083 - JSS: slots not freed
  This patch is based on release 9, which is newer than release 10.

* Tue Dec 21 2010 Christina Fu <cfu@redhat.com> - 4.2.6-9%{?dist}
- bug 654657 - <jdennis@redhat.com>
  Incorrect socket accept error message due to bad pointer arithmetic
- bug 661142 - <cfu@redhat.com>
  Verification should fail when a revoked certificate is added

* Mon Nov 1 2010 Christina Fu <cfu@redhat.com> 4.2.6-8%{?dist}
- Bugzilla Bug # 647364 - Expose updated certificate verification function in JSS

* Wed Oct 20 2010 Christina Fu <cfu@redhat.com> 4.2.6-7%{?dist}
- Bugzilla Bug # 638833 - rfe ecc - add ec curve name support in JSS and CS
 
* Thu Nov 5 2009 Christina Fu <cfu@redhat.com> 4.2.6-6%{?dist}
- Bugzilla Bug # 529945 - expose NSS calls for OCSP settings
 
* Tue Jul 28 2009 Christina Fu <cfu@redhat.com> 4.2.6-5%{?dist}
- Bugzilla Bug #224688 -  Support ECC POP on the server

* Mon Jul 6 2009 Matthew Harmsen <mharmsen@redhat.com> 4.2.6-4%{?dist}
- Bugzilla Bug #509183 -  update nss dependency >= 3.12.3.99

* Fri Jun 19 2009 Jack Magne <jmagne@redhat.com> 4.2.6-3%{?dist}
- Bugzilla Bug #469456 -  Server Sockets are hard coded to IPV4

* Mon Jun 8 2009 Matthew Harmsen <mharmsen@redhat.com> 4.2.6-2%{?dist}
- Bugzilla Bug #503809 -  Update JSS version to 4.2.6 (use correct tarball)
- Update License string to be more specific on versions (rcritten@redhat.com)
- Include patch to fix missing @param in javadocs (rcritten@redhat.com)
- Added signature verification

* Tue Jun 2 2009 Christina Fu <cfu@redhat.com> 4.2.6-1%{?dist}
- Bugzilla Bug #455305 -  CA ECC Signing Key Failure
- Bugzilla Bug #502111 -  Need JSS interface for NSS's
  PK11_GenerateKeyPairWithOpFlags() function
- Bugzilla Bug #503809 -  Update JSS version to 4.2.6
- Bugzilla Bug #503817 -  Create JSS Javadocs as their own RPM

* Mon Nov 10 2008 Matthew Harmsen <mharmsen@redhat.com> 4.2.5-1%{?dist}
- Updated JSS version to 4.2.5.
- Updated BuildRequires for nspr-devel >= 4.6.99
- Updated BuildRequires for nss-devel >= 3.12.0
- Updated BuildRequires for java-devel >= 1.6.0
- Updated BuildRequires for pkgconfig
- Force BuildRequires to use java-devel-openjdk >= 1.6.0 (OpenJDK 1.6.0)
- Updated Requires for nss >= 3.12.0
- Updated Requires for java >= 1.6.0

* Fri Oct 12 2007 Margaret Lum <mlum@redhat.com> 4.2.4-41.el5idm
- Build with IBM JVM 1.4.2.  Rebuild.  Added LD_PRELOAD back in for 232224.
- Updated BuildRequires for java-1.4.2-ibm. 

* Tue Sep 04 2007 Margaret Lum <mlum@redhat.com> 4.2.4-37.el5idm
- Define JAVA_HOME for build_java.pl

* Thu Aug 30 2007 Margaret Lum <mlum@redhat.com> 4.2.4-36.el5idm
- Revert back to gcj 1.4.2 since 1.5 (IBM) compiled doesn't work with Marathon for DS

* Tue Aug 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-35.el5idm
- Removed extraneous copy of jss4.jar under /usr/libARCH/java

* Tue Aug 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-31.el5idm
- Create the libdir/java for xpclass.jar to be copied.

* Tue Aug 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-30.el5idm
- Disable signing until all dependencies are built.

* Tue Aug 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-29.el5idm
- Add pkgconfig to BuildRequires.

* Sun Jul 22 2007 Margaret Lum <mlum@redhat.com> 4.2.4-28.el5idm
- Using IBM JVM for now; requires LD_PRELOAD for bug 232224

* Sat Jul 21 2007 Margaret Lum <mlum@redhat.com> 4.2.4-27.el5idm
- Require java >= 1.5.0, since multiple jvms are tagged in buildroot

* Sat Jul 21 2007 Margaret Lum <mlum@redhat.com> 4.2.4-26.el5idm
- Latest import from Fedora, including rpmsigning of jar

* Thu May 24 2007 Rob Crittenden <rcritten@redhat.com> 4.2.4-6
- Use _jnidir macro instead of _javadir for the jar files. This will break
  multilib installs but adheres to the jpackage spec.

* Wed May 16 2007 Rob Crittenden <rcritten@redhat.com> 4.2.4-5
- Include the 3 license files
- Remove Requires for nss and nspr. These libraries have versioned symbols
  so BuildRequires is enough to set the minimum.
- Add sparc64 for the 64-bit list

* Mon May 14 2007 Rob Crittenden <rcritten@redhat.com> 4.2.4-4
- Included additional comments on jar signing and why ldconfig is not
  required.

* Thu May 10 2007 Rob Crittenden <rcritten@redhat.com> 4.2.4-3
- Added information on how to pull the source into a tar.gz

* Thu Mar 15 2007  Rob Crittenden <rcritten@redhat.com> 4.2.4-2
- Added RPM_OPT_FLAGS to XCFLAGS

- Added link to Sun JCE information
* Mon Feb 27 2007 Rob Crittenden <rcritten@redhat.com> 4.2.4-1
- Initial build

